/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.TarifaCategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.TarifaCategoria;
import com.rjconsultores.ventaboletos.service.TarifaCategoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author rodrigo
 */
@Service("tarifaCategoriaService")
public class TarifaCategoriaServiceImpl implements TarifaCategoriaService {

    @Autowired
    private TarifaCategoriaDAO tarifaCategoriaDAO;

    public List<TarifaCategoria> obtenerTodos() {
        return tarifaCategoriaDAO.obtenerTodos();
    }

    public TarifaCategoria obtenerID(Integer id) {
        return tarifaCategoriaDAO.obtenerID(id);
    }

    @Transactional
    public TarifaCategoria suscribir(TarifaCategoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tarifaCategoriaDAO.suscribir(entidad);
    }

    @Transactional
    public TarifaCategoria actualizacion(TarifaCategoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tarifaCategoriaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(TarifaCategoria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        tarifaCategoriaDAO.actualizacion(entidad);
    }

    public List<TarifaCategoria> buscar(Categoria categoria) {
        return tarifaCategoriaDAO.buscarPorCategoria(categoria);
    }
}
